=== debian/control ===
Source: iceoryx
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libcpptoml-dev,
Build-Depends-Arch:
               libacl1-dev,
               libgmock-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               libncurses-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               graphviz <!nodoc>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://projects.eclipse.org/proposals/eclipse-iceoryx
Vcs-Git: https://salsa.debian.org/robotics-team/iceoryx.git
Vcs-Browser: https://salsa.debian.org/robotics-team/iceoryx

Package: iceoryx
Section: net
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the central RouDi daemon and the introspection
 tool for Iceoryx.

Package: libiceoryx-binding-c1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C bindings for the zero-copy inter-process communication library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This library provides the C bindings for Iceoryx.

Package: libiceoryx-binding-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libiceoryx-posh-dev (= ${binary:Version}),
         libiceoryx-utils-dev (= ${binary:Version}),
         libiceoryx-binding-c1 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: C bindings for the zero-copy inter-process communication library (headers)
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the development headers for the C bindings of Iceoryx.

Package: libiceoryx-posh1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication POSH runtime library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the POSH runtime library of Iceoryx.

Package: libiceoryx-posh-roudi1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication POSH RouDi library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the POSH RouDi library of Iceoryx.

Package: libiceoryx-posh-gateway1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication POSH Gateway library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the POSH Gateway library of Iceoryx.

Package: libiceoryx-posh-config1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication POSH config library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the POSH config library of Iceoryx.

Package: libiceoryx-posh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libiceoryx-utils-dev (= ${binary:Version}),
         libiceoryx-posh1 (= ${binary:Version}),
         libiceoryx-posh-config1 (= ${binary:Version}),
         libiceoryx-posh-gateway1 (= ${binary:Version}),
         libiceoryx-posh-roudi1 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: zero-copy inter-process communication POSH library headers
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the development headers for the POSH libraries
 of Iceoryx.

Package: libiceoryx-utils1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication utilities library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the utilities library of Iceoryx.

Package: libiceoryx-platform1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication platform library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the platform library of Iceoryx.

Package: libiceoryx-utils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libiceoryx-platform1 (= ${binary:Version}),
         libiceoryx-utils1 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: zero-copy inter-process communication utilities library headers
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provide the development headers for the utilities and
 platform library of Iceoryx.

Package: libiceoryx-introspection1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zero-copy inter-process communication introspection library
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provides the introspection library of Iceoryx.

Package: libiceoryx-introspection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libiceoryx-posh-dev (= ${binary:Version}),
         libiceoryx-utils-dev (= ${binary:Version}),
         libiceoryx-introspection1 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: zero-copy inter-process communication introspection library headers
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.
 .
 This package provide the development headers for the introspection library of
 Iceoryx.

Package: iceoryx-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: zero-copy inter-process communication library documentation
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
