=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/,\
     uversionmangle=s/[-.]?(a|b|pre)/~$1/,dversionmangle=s/\+dfsg\d*$//,\
     oversionmangle=s/$/+dfsg/,repack \
  https://github.com/eclipse-iceoryx/iceoryx/releases (?:.*/)?v?(\d\S+)\.tar\.gz
